package me.parsell.wireddust.common;

import net.minecraft.util.StringIdentifiable;

public enum WDWireConnection implements StringIdentifiable{
  UP("up"),
  SIDE("side"),
  BROKE("broke"),
  NONE("none");

  private final String name;

  private WDWireConnection(String name){
    this.name = name;
  }

  public String toString() {
    return this.asString();
  }

 public String asString() {
    return this.name;
  }

  public boolean isBroken() {
    return this == BROKE;
  }

 public boolean isConnected() {
    return this != NONE && this != BROKE;
  }

  public boolean isConnectedUp(){
    return this == UP;
  }
}
