package me.parsell.wireddust.core;

import java.util.HashMap;
import java.util.Map;

import me.parsell.wireddust.WiredDust;
import me.parsell.wireddust.common.WDBlazePowderWireBlock;
import me.parsell.wireddust.common.WDGunpowderWireBlock;
import me.parsell.wireddust.common.WDWireBlock;
import net.fabricmc.fabric.api.object.builder.v1.block.FabricBlockSettings;
import net.minecraft.block.Block;
import net.minecraft.block.Material;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.Registry;

public class WiredDustBlocks {
  public static Map<ItemStack, Block> WDITEM_TO_BLOCK = new HashMap<ItemStack, Block>();

  public static final Block GLOWSTONE_WIRE = new WDWireBlock(FabricBlockSettings.of(Material.SUPPORTED).breakInstantly().noCollision().luminance(9));
  public static final Block GUNPOWDER_WIRE = new WDGunpowderWireBlock(FabricBlockSettings.of(Material.SUPPORTED).breakInstantly().noCollision());
  public static final Block BLAZE_POWDER_WIRE = new WDBlazePowderWireBlock(FabricBlockSettings.of(Material.SUPPORTED).breakInstantly().noCollision().luminance(2)); 
  public static final Block SUGAR_WIRE = new WDWireBlock(FabricBlockSettings.of(Material.SUPPORTED).breakInstantly().noCollision());

  public static void init(){
    Registry.register(Registry.BLOCK, new Identifier(WiredDust.MODID, "glowstone_wire"), GLOWSTONE_WIRE);
    Registry.register(Registry.BLOCK, new Identifier(WiredDust.MODID, "gunpowder_wire"), GUNPOWDER_WIRE);
    Registry.register(Registry.BLOCK, new Identifier(WiredDust.MODID, "blaze_powder_wire"), BLAZE_POWDER_WIRE);
    Registry.register(Registry.BLOCK, new Identifier(WiredDust.MODID, "sugar_wire"), SUGAR_WIRE);

    WDITEM_TO_BLOCK.put(new ItemStack(Items.GLOWSTONE_DUST), GLOWSTONE_WIRE);
    WDITEM_TO_BLOCK.put(new ItemStack(Items.SUGAR), SUGAR_WIRE);
  }
}
